#include<bits/stdc++.h>

using namespace std;

long long max_int = LLONG_MAX;

int main()
{
    int n,m;
    cin >> n >> m;
    vector<vector<int>> navijaci(n);
    vector<vector<long long>> najeftiniji_put(n);
    int guzva;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin >> guzva;
            navijaci[i].push_back(guzva);
            najeftiniji_put[i].push_back(0);
        }
    }

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(i==0 && j==0)
            {
                najeftiniji_put[i][j] = navijaci[i][j];
            }
            else if(i==0)
            {
                najeftiniji_put[i][j] = navijaci[i][j]+najeftiniji_put[i][j-1];
            }
            else if(j==0)
            {
                najeftiniji_put[i][j] = navijaci[i][j] + najeftiniji_put[i-1][j];
            }
            else
            {
                najeftiniji_put[i][j] = navijaci[i][j] + min(najeftiniji_put[i][j-1],najeftiniji_put[i-1][j]);
            }
        }
    }
    int x;
    cin >> x;
    int a,b;
    for(int k=0; k<x; k++)
    {
        cin >> a >> b;
        a--;
        b--;
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<m; j++)
            {
                if(i == a && j == b)
                {
                    najeftiniji_put[i][j] = max_int;
                }
                else if(i==0 && j==0)
                {
                    najeftiniji_put[i][j] = navijaci[i][j];
                }
                else if(i==0)
                {
                    if(najeftiniji_put[i][j-1] == max_int)
                    {
                        najeftiniji_put[i][j] = max_int;
                    }
                    else
                    {
                        najeftiniji_put[i][j] = navijaci[i][j]+najeftiniji_put[i][j-1];
                    }
                }
                else if(j==0)
                {
                    if(najeftiniji_put[i-1][j] == max_int)
                    {
                        najeftiniji_put[i][j] = max_int;
                    }
                    else
                    {
                        najeftiniji_put[i][j] = navijaci[i][j] + najeftiniji_put[i-1][j];
                    }

                }
                else
                {
                    najeftiniji_put[i][j] = navijaci[i][j] + min(najeftiniji_put[i][j-1],najeftiniji_put[i-1][j]);
                }
            }
        }
        cout << najeftiniji_put[n-1][m-1] << endl;
    }

}